



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LeetCode:N-Queens I II（n皇后问题）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LeetCode:N-Queens I II（n皇后问题）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-06 03:25:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://oj.leetcode.com/problems/n-queens/" rel="external nofollow noreferrer">N-Queens</a></p>
<p>The <em>n</em>-queens puzzle is the problem of placing <em>n</em> queens on an <em>n</em>&times;<em>n</em> chessboard such that no two queens attack each other.</p>
<p><img referrerpolicy="no-referrer"src="http://www.leetcode.com/wp-content/uploads/2012/03/8-queens.png" /></p>
<p>Given an integer <em>n</em>, return all distinct solutions to the <em>n</em>-queens puzzle.</p>
<p>Each solution contains a distinct board configuration of the <em>n</em>-queens' placement, where <code>'Q'</code> and <code>'.'</code> both indicate a queen and an empty space respectively.</p>
<p>For example, <br />There exist two distinct solutions to the 4-queens puzzle:</p>
<pre class="prettyprint linenums">[<br />
 [".Q..",  // Solution 1<br />
  "...Q",<br />
  "Q...",<br />
  "..Q."],

 ["..Q.",  // Solution 2<br />
  "Q...",<br />
  "...Q",<br />
  ".Q.."]<br />
]</pre>
<p><strong>算法1</strong></p>
<p>这种棋盘类的题目一般是回溯法, 依次放置每行的皇后。在放置的时候，要保持当前的状态为合法，即当前放置位置的同一行、同一列、两条对角线上都不存在皇后。</p>
<pre class="prettyprint linenums">class Solution {<br />
private:<br />
    vector&lt;vector&lt;string&gt; &gt; res;<br />
public:<br />
    vector&lt;vector&lt;string&gt; &gt; solveNQueens(int n) {<br />
        vector&lt;string&gt;cur(n, string(n,'.'));<br />
        helper(cur, 0);<br />
        return res;<br />
    }<br />
    void helper(vector&lt;string&gt; &amp;cur, int row)<br />
    {<br />
        if(row == cur.size())<br />
        {<br />
            res.push_back(cur);<br />
            return;<br />
        }<br />
        for(int col = 0; col &lt; cur.size(); col++)<br />
            if(isValid(cur, row, col))<br />
            {<br />
                cur[row][col] = 'Q';<br />
                helper(cur, row+1);<br />
                cur[row][col] = '.';<br />
            }<br />
    }

    //判断在cur[row][col]位置放一个皇后，是否是合法的状态<br />
    //已经保证了每行一个皇后，只需要判断列是否合法以及对角线是否合法。<br />
    bool isValid(vector&lt;string&gt; &amp;cur, int row, int col)<br />
    {<br />
        //列<br />
        for(int i = 0; i &lt; row; i++)<br />
            if(cur[i][col] == 'Q')return false;<br />
        //右对角线(只需要判断对角线上半部分，因为后面的行还没有开始放置)<br />
        for(int i = row-1, j=col-1; i &gt;= 0 &amp;&amp; j &gt;= 0; i--,j--)<br />
            if(cur[i][j] == 'Q')return false;<br />
        //左对角线(只需要判断对角线上半部分，因为后面的行还没有开始放置)<br />
        for(int i = row-1, j=col+1; i &gt;= 0 &amp;&amp; j &lt; cur.size(); i--,j++)<br />
            if(cur[i][j] == 'Q')return false;<br />
        return true;<br />
    }<br />
};</pre>
<p><strong>算法2</strong></p>
<p>上述判断状态是否合法的函数还是略复杂，其实只需要用一个一位数组来存放当前皇后的状态。假设数组为int state[n], state[i]表示第 i 行皇后所在的列。那么在新的一行 k 放置一个皇后后:</p>
<ul><li>判断列是否冲突，只需要看state数组中state[0&hellip;k-1] 是否有和state[k]相等；</li>
<li>判断对角线是否冲突：如果两个皇后在同一对角线，那么|row1-row2| = |column1 - column2|，（row1，column1），（row2，column2）分别为冲突的两个皇后的位置</li></ul>
<pre class="prettyprint linenums">class Solution {<br />
private:<br />
    vector&lt;vector&lt;string&gt; &gt; res;<br />
public:<br />
    vector&lt;vector&lt;string&gt; &gt; solveNQueens(int n) {<br />
        vector&lt;int&gt; state(n, -1);<br />
        helper(state, 0);<br />
        return res;<br />
    }<br />
    void helper(vector&lt;int&gt; &amp;state, int row)<br />
    {//放置第row行的皇后<br />
        int n = state.size();<br />
        if(row == n)<br />
        {<br />
            vector&lt;string&gt;tmpres(n, string(n,'.'));<br />
            for(int i = 0; i &lt; n; i++)<br />
                tmpres[i][state[i]] = 'Q';<br />
            res.push_back(tmpres);<br />
            return;<br />
        }<br />
        for(int col = 0; col &lt; n; col++)<br />
            if(isValid(state, row, col))<br />
            {<br />
                state[row] = col;<br />
                helper(state, row+1);<br />
                state[row] = -1;;<br />
            }<br />
    }

    //判断在row行col列位置放一个皇后，是否是合法的状态<br />
    //已经保证了每行一个皇后，只需要判断列是否合法以及对角线是否合法。<br />
    bool isValid(vector&lt;int&gt; &amp;state, int row, int col)<br />
    {<br />
        for(int i = 0; i &lt; row; i++)//只需要判断row前面的行，因为后面的行还没有放置<br />
            if(state[i] == col || abs(row - i) == abs(col - state[i]))<br />
                return false;<br />
        return true;<br />
    }<br />
};</pre>
<p><strong>算法3</strong>：(算法2的非递归版）</p>
<pre class="prettyprint linenums">class Solution {<br />
private:<br />
    vector&lt;vector&lt;string&gt; &gt; res;<br />
public:<br />
    vector&lt;vector&lt;string&gt; &gt; solveNQueens(int n) {<br />
        vector&lt;int&gt; state(n, -1);<br />
        for(int row = 0, col; ;)<br />
        {<br />
            for(col = state[row] + 1; col &lt; n; col++)//从上一次放置的位置后面开始放置<br />
            {<br />
                if(isValid(state, row, col))<br />
                {<br />
                    state[row] = col;<br />
                    if(row == n-1)//找到了一个解,继续试探下一列<br />
                    {<br />
                        vector&lt;string&gt;tmpres(n, string(n,'.'));<br />
                        for(int i = 0; i &lt; n; i++)<br />
                            tmpres[i][state[i]] = 'Q';<br />
                        res.push_back(tmpres);<br />
                    }<br />
                    else {row++; break;}//当前状态合法，去放置下一行的皇后<br />
                }<br />
            }<br />
            if(col == n)//当前行的所有位置都尝试过，回溯到上一行<br />
            {<br />
                if(row == 0)break;//所有状态尝试完毕，退出<br />
                state[row] = -1;//回溯前清除当前行的状态<br />
                row--;<br />
            }<br />
        }<br />
        return res;<br />
    }

    //判断在row行col列位置放一个皇后，是否是合法的状态<br />
    //已经保证了每行一个皇后，只需要判断列是否合法以及对角线是否合法。<br />
    bool isValid(vector&lt;int&gt; &amp;state, int row, int col)<br />
    {<br />
        for(int i = 0; i &lt; row; i++)//只需要判断row前面的行，因为后面的行还没有放置<br />
            if(state[i] == col || abs(row - i) == abs(col - state[i]))<br />
                return false;<br />
        return true;<br />
    }<br />
};</pre>
<p><strong>算法4（解释在后面）这应该是最高效的算法了</strong></p>
<pre class="prettyprint linenums">class Solution {<br />
private:<br />
    vector&lt;vector&lt;string&gt; &gt; res;<br />
    int upperlim;<br />
public:<br />
    vector&lt;vector&lt;string&gt; &gt; solveNQueens(int n) {<br />
        upperlim = (1 &lt;&lt; n) - 1;//低n位全部置1<br />
        vector&lt;string&gt; cur(n, string(n, '.'));<br />
        helper(0,0,0,cur,0);<br />
        return res;<br />
    }

    void helper(const int row, const int ld, const int rd, vector&lt;string&gt;&amp;cur, const int index)<br />
    {<br />
    	int pos, p;<br />
    	if ( row != upperlim )<br />
    	{<br />
    		pos = upperlim &amp; (~(row | ld | rd ));//pos中二进制为1的位，表示可以在当前行的对应列放皇后<br />
    		//和upperlim与运算，主要是ld在上一层是通过左移位得到的，它的高位可能有无效的1存在，这样会清除ld高位无效的1<br />
    		while ( pos )<br />
    		{<br />
    			p = pos &amp; (~pos + 1);//获取pos最右边的1,例如pos = 010110，则p = 000010<br />
    			pos = pos - p;//pos最右边的1清0<br />
    			setQueen(cur, index, p, 'Q');//在当前行，p中1对应的列放置皇后<br />
    			helper(row | p, (ld | p) &lt;&lt; 1, (rd | p) &gt;&gt; 1, cur, index+1);//设置下一行<br />
    			setQueen(cur, index, p, '.');<br />
    		}<br />
    	}<br />
    	else//找到一个解<br />
            res.push_back(cur);<br />
    }

    //第row行，第loc1(p)列的位置放置一个queen或者清空queen，loc1(p)表示p中二进制1的位置<br />
    void setQueen(vector&lt;string&gt;&amp;cur, const int row, int p, char val)<br />
    {<br />
        int col = 0;<br />
        while(!(p &amp; 1))<br />
        {<br />
            p &gt;&gt;= 1;<br />
            col++;<br />
        }<br />
        cur[row][col] = val;<br />
    }<br />
};</pre>
<p>这个算法主要参考博客<a href="http://blog.csdn.net/hackbuteer1/article/details/6657109" rel="external nofollow noreferrer">N皇后问题的两个最高效的算法</a>，主要看helper函数，<strong>参数row、ld、rd分别表示在列和两个对角线方向的限制条件下，当前行的哪些地方不能放置皇后</strong>。如下图</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/517264/201406/212304437397178.png" /></p>
<p>前三行放置了皇后，他们对第3行（行从0开始）的影响如下：&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href="http://www.cnblogs.com/TenosDoIt/p/3801621.html" rel="external nofollow noreferrer">本文地址</a></p>
<p>（1）列限制条件下，第3行的0、2、4列（紫色线和第3行的交点）不能放皇后，因此row = 101010</p>
<p>（2）左对角线限制条件下，第3行的0、3列（蓝色线和第3行的交点）不能放皇后，因此ld = 100100</p>
<p>（3）右对角线限制条件下，第3行的3、4、5列（绿色线和第3行的交点）不能放皇后，因此rd = 000111</p>
<p>~(row | ld | rd) = 010000，即第三行只有第1列能放置皇后。</p>
<p>在3行1列这个位置放上皇后，row，ld，rd对下一行的影响为：</p>
<p>row的第一位置1，变为111010</p>
<p>ld的第一位置1，并且向左移1位（因为左对角线对行的影响是依次向左倾斜的），变为101000</p>
<p>rd的第一位置1，并且向右移1位（因为右对角线对行的影响是依次向右倾斜的），变为001011</p>
<p>第4行状态如下图</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/517264/201406/212301335209165.png" /></p>
<hr />
<p><a href="https://oj.leetcode.com/problems/n-queens-ii/" rel="external nofollow noreferrer">N-Queens II</a></p>
<p>Follow up for N-Queens problem.</p>
<p>Now, instead outputting board configurations, return the total number of distinct solutions.</p>
<p><img referrerpolicy="no-referrer"src="http://www.leetcode.com/wp-content/uploads/2012/03/8-queens.png" /></p>
<p>这一题就是上一题的简化版了，我们只针对上面的算法2来求解这一题</p>
<pre class="prettyprint linenums">class Solution {<br />
private:<br />
    int res;<br />
public:<br />
    int totalNQueens(int n) {<br />
        vector&lt;int&gt; state(n, -1);<br />
        res = 0;<br />
        helper(state, 0);<br />
        return res;<br />
    }<br />
    void helper(vector&lt;int&gt; &amp;state, int row)<br />
    {//放置第row行的皇后<br />
        int n = state.size();<br />
        if(row == n)<br />
        {<br />
            res++;<br />
            return;<br />
        }<br />
        for(int col = 0; col &lt; n; col++)<br />
            if(isValid(state, row, col))<br />
            {<br />
                state[row] = col;<br />
                helper(state, row+1);<br />
                state[row] = -1;;<br />
            }<br />
    }

    //判断在row行col列位置放一个皇后，是否是合法的状态<br />
    //已经保证了每行一个皇后，只需要判断列是否合法以及对角线是否合法。<br />
    bool isValid(vector&lt;int&gt; &amp;state, int row, int col)<br />
    {<br />
        for(int i = 0; i &lt; row; i++)//只需要判断row前面的行，因为后面的行还没有放置<br />
            if(state[i] == col || abs(row - i) == abs(col - state[i]))<br />
                return false;<br />
        return true;<br />
    }

};</pre>
<p><strong>【版权声明】转载请注明出处：<a href="http://www.cnblogs.com/TenosDoIt/p/3801621.html" rel="external nofollow noreferrer">http://www.cnblogs.com/TenosDoIt/p/3801621.html</a></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwlnnr9.html">python time和datetime的常用转换处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96lp249.html">&lbrack;08&rsqb;APUE：进程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gk1jl8.html">高端大气上档次Ergotron Neo-Flex＋MBP Retina的组合~</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxxp5jq.html">RGB to HSI&comma; HSI to RGB Conversion Calculator</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xg6nm8.html">解决数据标准及质量AppScan（测试）安全性问题相关方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zog53nq.html">不用SWIG，Go使用C&plus;&plus;代码的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vvyoq.html">sql server日期字段值的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zme4x9.html">安装ipvsadm报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1o4ljq.html">3&period;2&period;2 break 与 continue 语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ym75g8.html">百度 Javascript开发 API</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdlzx49.html">Java提高篇（二）：IO字节流、字符流和处理流</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmm078.html">npm5踩过的坑！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25mgpvq.html">Docker 从入门到放弃（二）容器使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r516vdq.html">5、python的变量和常量</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1mwn9.html">ContentProvider使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7owodx8.html">实现在某一指定位置的div在窗口滚动到指定位置的时候fixed定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw4p378.html">java进程占用系统内存高，排查解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7opege8.html">Android&lowbar;触摸事件传递机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kxy43q.html">&lbrack;转载&rsqb;几个有趣的Linux命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn05keq.html">elment-ui table组件 -- 远程筛选排序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8o4jgeq.html">WebStorage记录滚动条位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvee119.html">MyEclipse快捷键大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9633g39.html">scrollview 图片放大 捏合 瓦片地图 相关注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2kmkwq.html">iOS--UIAlertView与UIAlertController和UIAlertAction之间的事儿</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4pmdjq.html">CSS3-05 样式 4</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql1n7k9.html">The operation couldn&rsquo;t be completed&period; &lpar;LaunchServicesError error 0&period;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o45dlq.html">IT人创业之融资方式 - 创业与投资系列文章</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4pn03q.html">控制Arduino的利器-Windows Remote Arduino</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rn1weq.html">SQL SERVER出现大量一致性错误的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jm2wg9.html">分布式架构中一致性解决方案&mdash;&mdash;Zookeeper集群搭建</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
